=== debian/changelog ===
toil (5.12.0-2) unstable; urgency=medium

  * d/tests/run-unit-tests: fix typo.
  * Added patch to the tests: only request a single core. Closes:
    #1031192
  * d/clean: remove docs/autoapi and another straggler. Closes: #1047298

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 22 Aug 2023 15:46:37 +0200

toil (5.12.0-1) unstable; urgency=medium

  * New upstream version
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  * refreshed patches.
  * d/rules: wdltoil_test has a new path.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 21 Aug 2023 19:09:01 +0200
