=== debian/tests/control ===
Tests: smoke-test
Depends: toil
Restrictions: allow-stderr, superficial

Tests: run-unit-tests
Depends: toil, python3, python3-wdlparse, python3-pytest, python3-pytest-xdist, python3-mock, python3-boto3, rsync, python3-boto, python3-stubserver, python3-yaml, quilt, docker.io
Restrictions: allow-stderr, needs-internet
