=== debian/changelog ===
toil (6.1.0-4) unstable; urgency=medium

  * d/control: we now need an explicit dependency on python3-tz. Closes:
    #1070055

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 29 Apr 2024 16:41:47 +0200

toil (6.1.0-3) unstable; urgency=medium

  * d/README.source: make more explicit the need to follow the
    instructions in debian/patch/settings_version.patch on every new
    source tarball.
  * d/control: drop unneeded dependency on python3-distutils.
    Closes: #1065987

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 11 Mar 2024 12:14:38 +0100

toil (6.1.0-2) unstable; urgency=medium

  * d/control: azure support is gone, don't suggest it anymore.

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 28 Feb 2024 15:20:36 +0100

toil (6.1.0-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * Run test for all supported Python versions
  * Do not force any specific docker version, just take the Debian
    packaged one

  [ Michael R. Crusoe ]
  * d/patches/setting_version.patch: regenerate according to the
    intructions in d/README.source.
  * d/tests/run-unit-tests: two more tests need skipping.

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 28 Feb 2024 11:42:03 +0100

toil (6.0.0-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
    Closes: #1058195
  * Drop python3-future from Build-Depends
    Closes: #1059945
  * Drop python3-boto from (Build-/Test-)Depends since upstream considers
    this module optional (see
     https://github.com/DataBiosphere/toil/issues/4718#issuecomment-1904474636
    )
    Closes: #1058237
  * Build-Depends: python3-configargparse
  * Soften versioned dependency from cwltool

  [ Michael R. Crusoe ]
  * d/rules,d/control, d/patches/intersphinx: Fix some sphinx warnings, ignore
                                              the rest.
  * Add patch to avoid need for ruamel.yaml.string package.
  * Add patch to allow for older configarparser version.
  * Ignore the new test_cactus_integration
  * Enhance avoid_boto patch
  * d/patches: updated metatdata
  * d/copyright: upstream removed wdl_functions.py
  * Add patch to remove use of distutils by copying in strtobool().
  * d/control: bump some minimum versions

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 23 Jan 2024 15:24:30 +0100
