=== debian/control ===
--- 
+++ 
@@ -8,19 +8,16 @@
                dh-sequence-python3,
                python3-all:any,
                python3-setuptools,
+               python3-configargparse,
                python3-docker,
                python3-dill,
-               python3-future,
-               cwltool (>= 3.1.20230601100705),
+               cwltool (>= 3.1.20240112164112),
                python3-schema-salad (>= 8.4.20230128170514),
-               python3-distutils,
                python3-enlighten,
                python3-wdlparse,
                python3-pytest <!nocheck>,
                python3-pytest-xdist <!nocheck>,
-               python3-mock <!nocheck>,
                python3-boto3 (>=1.17) <!nocheck>,
-               python3-boto <!nocheck>,
                python3-stubserver <!nocheck>,
                rsync <!nocheck>,
                python3-yaml <!nocheck>,
@@ -30,7 +27,9 @@
                python3-sphinx-autoapi <!nodoc>,
                python3-sphinx-autodoc-typehints <!nodoc>,
                python3-sphinxcontrib.autoprogram <!nodoc>,
-               python3-pubsub <!nodoc>
+               python3-pubsub <!nodoc>,
+               python3-doc <!nodoc>,
+               python3-tz <!nodoc> <!nocheck>
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/toil
 Vcs-Git: https://salsa.debian.org/med-team/toil.git
@@ -41,20 +40,13 @@
 Architecture: all
 Depends: ${python3:Depends},
          ${misc:Depends},
-         python3-distutils,
-         cwltool (>= 3.1.20221201130942),
+         cwltool (>= 3.1.20240112164112),
          python3-schema-salad (>= 8.4.20230128170514),
-         python3-boto,
          python3-boto3
-# for google cloud support
 Recommends: python3-libcloud
-# for WDL support
-#           python3-wdlparse,
 # for mesos support, but needs python3-mesos first
 #           python3-protobuf,
 Suggests: podman | docker.io | singularity-container | docker-ce,
-          python3-azure,
-          python3-azure-storage,
           python3-idna,
 Provides: cwl-runner
 #Suggests: python-toil-doc
