=== debian/changelog ===
toil (8.0.0-5) unstable; urgency=medium

  * d/rules: skip flaky testServices. Closes: #1101085

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 09 Apr 2025 13:42:27 +0200

toil (8.0.0-4) unstable; urgency=medium

  * d/rules: skip the slow tests
  * d/patches/needs_aws-proxyfix: forwarded upstream

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 21 Mar 2025 17:28:28 +0100

toil (8.0.0-3) unstable; urgency=medium

  * d/tests/autopkgtest-pkg-pybuild.conf: fix typo

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 19 Mar 2025 18:39:08 +0100

toil (8.0.0-2) unstable; urgency=medium

  * d/watch: mark beta releases as such
  * Skip autopktests on 32-bit architectures
  * d/rules: skip the testMultiplejobs tests, they are flaky during
    parallel execution. Closes: #1100817

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 19 Mar 2025 12:41:12 +0100

toil (8.0.0-1) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * New upstream version
  * Refresh patches
  * d/patches/allow_newer_requests: added
  * docs: link to cwltool-doc; link to python3-doc locally
  * d/patches/skip-mypy-boto3: these type hints are not packaged for
    Debian yet
  * d/patches/needs_aws-proxyfix: Fix build due to purposely invalid
    proxy configuration.
  * d/rules: skip online tests
  * d/patches/setting_version.patch: update for Python 3.12
  * d/rules: use DEB_BUILD_OPTION_PARALLEL instead of "auto" for setting
    the amount of parallel testing.
  * Refreshed patches; removed "skip-mypy-boto3" and "python3.12-
    syntax.patch" as they are no longer needed.
  * Added patch to remove the restrictions on the psutil Python package
    version.
  * Updated the fix-tests patch to fix more tests.
  * d/control: cwl-utils is needed for the tests
  * Added patch with a minimal PEP-517 pyproject.toml, to improve how we
    run the tests.
  * d/rules: simplify
  * d/rules: skip manual page building in when the "nodoc" build profile
    is active.
  * Switch autopkgtest to autopkgtest-pkg-pybuild
  * d/TODO: removed several completed items.
  * d/toil.lintian-overrides: removed, no longer applicable
  * d/patches/soften-configargparser-deps: removed, no longed needed

  [ Andreas Tille ]
  * Fix Python3.12 string syntax
    Closes: #1087116
  * Standards-Version: 4.7.0 (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 18 Mar 2025 17:34:39 +0100
