=== debian/control ===
--- 
+++ 
@@ -6,8 +6,10 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-sequence-python3,
+               pybuild-plugin-pyproject,
                python3-all:any,
                python3-setuptools,
+               python3-setuptools-scm,
                python3-configargparse,
                python3-docker,
                python3-dill,
@@ -23,18 +25,21 @@
                python3-yaml <!nocheck>,
                docker.io <!nocheck>,
                python3-urllib3,
+               cwltool-doc <!nodoc>,
                python3-sphinx <!nodoc>,
                python3-sphinx-autoapi <!nodoc>,
                python3-sphinx-autodoc-typehints <!nodoc>,
                python3-sphinxcontrib.autoprogram <!nodoc>,
                python3-pubsub <!nodoc>,
                python3-doc <!nodoc>,
-               python3-tz <!nodoc> <!nocheck>
-Standards-Version: 4.6.2
+               python3-tz <!nodoc> <!nocheck>,
+               cwl-utils <!nocheck>
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/toil
 Vcs-Git: https://salsa.debian.org/med-team/toil.git
 Homepage: https://github.com/BD2KGenomics/toil
 Rules-Requires-Root: no
+Testsuite: autopkgtest-pkg-pybuild
 
 Package: toil
 Architecture: all
